import java.awt.Image;
import java.awt.Toolkit;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.net.URL;
import java.util.Random;

import javax.swing.ImageIcon;
import javax.swing.JCheckBox;
import javax.swing.JFileChooser;


public class Controller implements ActionListener {

	Model yapvModel;
	View yapvView;
	
	/**
	 * Creates a controller, generates the model and view and adds the view as an observer.
	 */
	public Controller() {
		yapvModel = new Model();
		yapvView = new View(this);
		
		yapvModel.addObserver(yapvView);
		
		yapvModel.disableButtons();
		
		yapvView.setVisible(true);
		
	}
	
	public void actionPerformed(ActionEvent event) {
		String cmd = event.getActionCommand();


		if (cmd.equals("Load File"))
		{ 
			openFile();
		}
		if (cmd.equals("Exit"))
		{
			System.exit(0);
		}
		if (cmd.equals("Medientechnik"))
		{
			yapvView.showAbout();
		}
		
		//only if there's a loaded image:
		if (yapvModel.getImage() != null)
		{

			if (cmd.equals("Alle Effekte"))
			{	//check and uncheck with a radio button:
				//if it is one, turn it off -- if it is off, turn it on
				if (yapvModel.getAllEnabled())
					{ 
					yapvModel.setAllEnabled(false);
					}
				else 
					{ 
					yapvModel.setAllEnabled(true); 
					}
				
			}
	
			if (cmd.equals("Random"))
			{
				//Very easy randomization...
				int filter = (int)Math.round(Math.random() * 5.9);
							
				switch (filter)
				{
					case 0:
						yapvModel.disableFilter("filter_blur, filter_distort, filter_sharpen, filter_contrast, filter_invert, filter_bw, filter_zoom");
						yapvModel.switchFilter("filter_blur");
						break;
					case 1:
						yapvModel.disableFilter("filter_blur, filter_distort, filter_sharpen, filter_contrast, filter_invert, filter_bw, filter_zoom");
						yapvModel.switchFilter("filter_distort");
						break;
					case 2:
						yapvModel.disableFilter("filter_blur, filter_distort, filter_sharpen, filter_contrast, filter_invert, filter_bw, filter_zoom");
						yapvModel.switchFilter("filter_sharpen");
						break;
					case 3:
						yapvModel.disableFilter("filter_blur, filter_distort, filter_sharpen, filter_contrast, filter_invert, filter_bw, filter_zoom");
						yapvModel.switchFilter("filter_contrast");
						break;
					case 4:
						yapvModel.disableFilter("filter_blur, filter_distort, filter_sharpen, filter_contrast, filter_invert, filter_bw, filter_zoom");
						yapvModel.switchFilter("filter_invert");
						break;
					case 5:
						yapvModel.disableFilter("filter_blur, filter_distort, filter_sharpen, filter_contrast, filter_invert, filter_bw, filter_zoom");
						yapvModel.switchFilter("filter_bw");
						break;
					case 6:
						yapvModel.disableFilter("filter_blur, filter_distort, filter_sharpen, filter_contrast, filter_invert, filter_bw, filter_zoom");
						yapvModel.switchFilter("filter_zoom");
						break;
				}
			}
			if (cmd.equals("filter_blur"))
			{
				yapvModel.switchFilter("filter_blur");
			}
			if (cmd.equals("filter_distort"))
			{
				yapvModel.switchFilter("filter_distort");
			}
			if (cmd.equals("filter_sharpen"))
			{
				yapvModel.switchFilter("filter_sharpen");
			}
			if (cmd.equals("filter_contrast"))
			{
				yapvModel.switchFilter("filter_contrast");
			}
			if (cmd.equals("filter_invert"))
			{
				yapvModel.switchFilter("filter_invert");
			}
			if (cmd.equals("filter_bw"))
			{
				yapvModel.switchFilter("filter_bw");
			}
			if (cmd.equals("filter_zoom"))
			{
				yapvModel.switchFilter("filter_zoom");
			}
 		}
		}
	
	/**
	 * Opens a FileChooser and set the new image within the model.
	 * optional: file filter for .jpg, ... 
	 */
	private void openFile() {
		JFileChooser fc = new JFileChooser();
				
		int state = fc.showOpenDialog( null );
		
	    if ( state == JFileChooser.APPROVE_OPTION )
	    {
		    yapvModel.setImage(fc.getSelectedFile().getPath());
		    yapvModel.disableFilter("filter_blur, filter_distort, filter_sharpen, filter_contrast, filter_invert, filter_bw, filter_zoom");
	    }
	}

}
